<?php

$img = imagecreatetruecolor(700, 500);

// Source triangle
const SRC_VECTOR = [
 -20, -5, // UP
   0,  0, // RIGHT (base value)
 -15, 15, // DOWN
];

const VECTOR_MULTIPLIER = 3; // Generic size multiplier

// Global offsets
const BASE_X = 50;
const BASE_Y = 200;

// The rest
$x = 0; 
$y = 0;
$vectors = set_vector($x, $y, 1);

// row size
$row_width = 20 / 3;

$col = 207;

for ($i = 0; $i < 8; ++$i) {
	
	$rad = deg2rad($i * 22.5);
	
	//$col = 127 + sin(deg2rad($i * 22.5)) * 128;
	//$c['bg'] 	= imagecolorallocatealpha($img, $col, $col, $col, 96);
	//$c['line'] 	= imagecolorallocatealpha($img, $col, $col, $col, 112);
	
	// "Nested" triangle loop
	for ($j = 1; $j <= $i; ++$j) {
		$vectors = set_vector($x, $y, $j);
		
		// I hope this counts as pastel colors
		$r = 127 + floor(sin($rad * $j)) * 128; 
		$g = 127 + floor(cos($rad * $j + 15)) * 128;
		$b = 127 + floor(sin($rad * $j + 30)) * 128;
		$c['bg'] 	= imagecolorallocatealpha($img, $r, $g, $b, 96);
		$c['line'] 	= imagecolorallocatealpha($img, $r, $g, $b, 112);
		
		imagefilledpolygon($img, $vectors, 3, $c['bg']);
		imagepolygon($img, $vectors, 3, $c['line']);
	}
	
	$x += ceil($row_width * 3.5);
	$y += -4;

}

header('Content-type: image/png');
imagepng($img);
imagedestroy($img);

// Duplicate size and reposition
function set_vector($x, $y, $multiplier) {
	$cnt = count(SRC_VECTOR);
	for ($i = 0; $i < $cnt; $i += 2) {
		$vectors[$i]   = (SRC_VECTOR[$i]   * $multiplier + $x) * VECTOR_MULTIPLIER + BASE_X;
		$vectors[$i+1] = (SRC_VECTOR[$i+1] * $multiplier + $y) * VECTOR_MULTIPLIER + BASE_Y;
	}
	return $vectors;
}