<?php

$img = imagecreatetruecolor(700, 700);

// Source triangle
const SRC_VECTOR = [
 -20, -5, // UP
   0,  0, // RIGHT (base value)
 -15, 15, // DOWN
];

const VECTOR_MULTIPLIER = 4; // Generic size multiplier

// Global offsets
const BASE_X = 20;
const BASE_Y = 300;

// The rest
$x = 0; 
$y = 0;
$vectors = set_vector($x, $y, 1);

// row size
$row_width = 20 / 3;

$c['set0'] = imagecolorallocatealpha($img, 255 / 2,179 / 2,186 / 2, 64 + 6 * 0);
$c['set1'] = imagecolorallocatealpha($img, 255 / 1.5,223 / 1.5,186 / 1.5, 64 + 6 * 1);
$c['set2'] = imagecolorallocatealpha($img, 186,225,255, 64 + 6 * 2);
$c['set3'] = imagecolorallocatealpha($img, 186,255,201, 64 + 6 * 3);
$c['set4'] = imagecolorallocatealpha($img, 255,255,186, 64 + 6 * 7);
$c['set5'] = imagecolorallocatealpha($img, 255,179,186, 64 + 6 * 7);
$c['set6'] = imagecolorallocatealpha($img, 255,223,186, 64 + 6 * 7);
$c['set7'] = imagecolorallocatealpha($img, 186,225,255, 64 + 6 * 7);



for ($i = 0; $i < 8; ++$i) {
	
	$rad = deg2rad($i * 22.5);
	
	//$col = 127 + sin(deg2rad($i * 22.5)) * 128;
	//$c['bg'] 	= imagecolorallocatealpha($img, $col, $col, $col, 96);
	//$c['line'] 	= imagecolorallocatealpha($img, $col, $col, $col, 112);
	
	// "Nested" triangle loop
	for ($j = 1; $j <= $i; ++$j) {
		$vectors = set_vector($x, $y, $j);
		
		imagefilledpolygon($img, $vectors, 3, $c["set".($j-1)]);
		imagepolygon($img, $vectors, 3, $c["set".($j-1)]);
	}
	
	$x += ceil($row_width * 3.5);
	$y += -4;

}

header('Content-type: image/png');
imagepng($img);
imagedestroy($img);

// Duplicate size and reposition
function set_vector($x, $y, $multiplier) {
	$cnt = count(SRC_VECTOR);
	for ($i = 0; $i < $cnt; $i += 2) {
		$vectors[$i]   = (SRC_VECTOR[$i]   * $multiplier + $x) * VECTOR_MULTIPLIER + BASE_X;
		$vectors[$i+1] = (SRC_VECTOR[$i+1] * $multiplier + $y) * VECTOR_MULTIPLIER + BASE_Y;
	}
	return $vectors;
}