<?php

const IMAGE_X = 900;
const IMAGE_Y = 700;


// Source triangle
const SRC_VECTOR = [
 -20, -5, // UP
   0,  0, // RIGHT (base value)
 -15, 15, // DOWN
];

const VECTOR_MULTIPLIER = 4; // Generic size multiplier

// Global offsets
const BASE_X = IMAGE_X - 20;
const BASE_Y = 200;

// Color settings
$alpha_fill = 110;
$alpha_bord = 0;

$colors = [
	50,  200, 255,
	100, 150, 255,
	150, 100, 255,
	200,  50, 255,
	255, 100, 200,
	255, 150, 100,
	255, 200, 150,
	255, 255, 200
];


// The rest
$img = imagecreatetruecolor(IMAGE_X, IMAGE_Y);

$x = 0; 
$y = 0;
$vectors = set_vector($x, $y, 1);

// row size
$row_width = 20 / 3;


imagealphablending($img, true);
$c['bg'] = imagecolorallocatealpha($img, 0, 0, 0, 127);
imagefill($img, 0, 0, $c['bg']);
imagesavealpha($img, true);



// Generate palette
for ($i = 0; $i < 8; ++$i) {
	$w 		= $i * 3;
	$c['set'.$i]	= imagecolorallocatealpha($img, $colors[$w], $colors[$w+1], $colors[$w+2], $alpha_fill);
	$c['bord'.$i]	= imagecolorallocatealpha($img, $colors[$w], $colors[$w+1], $colors[$w+2], $alpha_bord);
}

// The first color seems to have the most importance
for ($i = 7; $i >= 0; --$i) {
	
	$rad = deg2rad($i * 22.5);
	
	// "Nested" triangle loop
	for ($j = $i; $j >= 0; --$j) {
		$vectors = set_vector($x, $y, $j+1);
		
		imagefilledpolygon($img, $vectors, 3, $c["set".$j]);
		imagepolygon($img, $vectors, 3, $c["bord".$j]);
	}
	
	$x -= $row_width * 3.506;
	$y -= -6.5;

}

header('Content-type: image/png');
imagepng($img);
imagedestroy($img);

// Duplicate size and reposition
function set_vector($x, $y, $multiplier) {
	$cnt = count(SRC_VECTOR);
	for ($i = 0; $i < $cnt; $i += 2) {
		$vectors[$i]   = (SRC_VECTOR[$i]   * $multiplier + $x) * VECTOR_MULTIPLIER + BASE_X;
		$vectors[$i+1] = (SRC_VECTOR[$i+1] * $multiplier + $y) * VECTOR_MULTIPLIER + BASE_Y;
	}
	return $vectors;
}